;==============================================================================
;       Test Department's WINDOWS 32 BIT x86 ASSEMBLY example's        014
;==============================================================================

;==============================================================================
; ==> Part 014 : UpDown control class
;------------------------------------------------------------------------------
; Hello friends,
; Another control example, today we use the UpDown control.
; There are two ways to create this kind of control (like toolbars).
; The classic way is the usage of the API 'CreateWindowExA' with the
; 'msctls_updown32' class. We must also use API 'InitCommonControls'.
; The second way is the usage of API 'CreateUpDownControl' which have some
; advantages.
; Here I show both.
;
;
; TD                    td@crahkob.com

;==============================================================================
; Assembler directives
;------------------------------------------------------------------------------
.386                    ; the processor our program want run on
.Model Flat ,StdCall    ; always the same for Win9x (32 Bit)
option casemap:none     ; case sensitive !!!

;==============================================================================
; Include all files where API functins resist you want use, set correct path
;------------------------------------------------------------------------------
include D:\Masm32\include\windows.inc
includelib kernel32.lib
includelib user32.lib
includelib comctl32.lib
includelib gdi32.lib

;==============================================================================
; Declaration of used API functions,take a look into WIN32.HLP and *.inc files
;------------------------------------------------------------------------------
GetModuleHandleA        PROTO :DWORD
MessageBoxA             PROTO :DWORD,:DWORD,:DWORD,:DWORD
InitCommonControls      PROTO
CreateUpDownControl     PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,
                              :DWORD,:DWORD,:DWORD,:DWORD,:DWORD

LoadIconA               PROTO :DWORD,:DWORD
LoadCursorA             PROTO :DWORD,:DWORD
RegisterClassExA        PROTO :DWORD
CreateSolidBrush        PROTO :DWORD
CreateWindowExA         PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,:DWORD,
                              :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
ShowWindow              PROTO :DWORD,:DWORD
UpdateWindow            PROTO :DWORD
GetMessageA             PROTO :DWORD,:DWORD,:DWORD,:DWORD
TranslateMessage        PROTO :DWORD
DispatchMessageA        PROTO :DWORD
PostQuitMessage         PROTO :DWORD
DefWindowProcA          PROTO :DWORD,:DWORD,:DWORD,:DWORD
ExitProcess             PROTO :DWORD
DestroyWindow           PROTO :DWORD
DeleteObject            PROTO :DWORD
InvalidateRect          PROTO :DWORD,:DWORD,:DWORD
SendMessageA            PROTO :DWORD,:DWORD,:DWORD,:DWORD
LoadBitmapA             PROTO :DWORD,:DWORD
GetClientRect           PROTO :DWORD,:DWORD

;==============================================================================
; .const = the constants area starts here,constants are defined and fixed
;------------------------------------------------------------------------------
.const 
; - Parameter MAIN WINDOW CallBack Procedure ( API=RegisterClassExA ) -
WP1_CallBack            equ [ebp+4]     ;return address
WP1_hWnd                equ [ebp+8]     ;handle of window who receives message
WP1_uMsg                equ [ebp+12]    ;the message number
WP1_wParam              equ [ebp+16]    ;extra info about the message
WP1_lParam              equ [ebp+20]    ;extra info about the message

;==============================================================================
; .Data = the data area starts here, datas are defined but not fixed
;------------------------------------------------------------------------------
.Data
ClassName               db "TDClass_UpDownControl",0    ;name windows class
WindowName              db "UpDown Control example",0   ;titel bar
UpDownClassName         db "msctls_updown32",0          ;predefined class
EditClassName           db "EDIT",0                     ;predefined class
StaticClassName         db "STATIC",0                   ;predefined class

align 4
Xpos_org                dd 240          ;X orgin point window
Ypos_org                dd 160          ;Y orgin point window
Xpos_max                dd 320          ;max. window width
Ypos_max                dd 240          ;max. window height

maxImg                  dd 5            ;max. number of images in resource

align 4
; - WndClassEx Structure -
cbSize                  dd 0h           ;size in bytes of this structure
style                   dd 0h           ;window style
lpfnWndProc             dd 0h           ;address of user proc function
cbclsExtra              dd 0h           ;extra bytes to allocate set to 0
cbWndExtra              dd 0h           ;extra bytes class directive, rc file
hInstance               dd 0h           ;program handle(API=GetModuleHandleA)
hIcon                   dd 0h           ;handle of icon (API=LoadIconA)
hcursor                 dd 0h           ;handle of cursor (API=LoadCursor)
hbrBackground           dd 0h           ;background color, 0=transparent
lpszMenuName            dd 0h           ;name of menu class in resource file
lpszClassName           dd 0h           ;name of windows this window class
hIconSm                 dd 0h           ;iconhandle 0=search in resource file

; - Msg Structure -
hWnd                    dd 0h           ;handle of window who receives message
message                 dd 0h           ;the message number
wParam                  dd 0h           ;extra info about the message
lParam                  dd 0h           ;extra info about the message 
time                    dd 0h           ;time the message was posted 
xpt                     dd 0h           ;cursor x-position, POINT struc
ypt                     dd 0h           ;cursor x-position, POINT struc

;==============================================================================
; .Data? = the data? area starts here, not defined and not fixed
;------------------------------------------------------------------------------
.data?
align 4
hWnd_edit               dd ?            ;handle edit window
hWnd_editupdown         dd ?            ;handle updown control window
hWnd_static             dd ?            ;handle edit window
hWnd_staticupdown       dd ?            ;handle updown control window
hImg_static             dd ?            ;handle image
hObj_old                dd ?            ;handle old object

;==============================================================================
; .CODE = our code area starts here     Main=label of our program code
;------------------------------------------------------------------------------
.Code
Main:

;==============================================================================
; Always get your program ID first (API=GetModuleHandleA)
;------------------------------------------------------------------------------
push    0h                      ;lpModuleHandle, 0=get program handle
call    GetModuleHandleA        ;- API Function -
mov     hInstance,eax           ;return value in eax=handle of program

;==============================================================================
; UpDown control class seems to be part of common controls, force to init...
;------------------------------------------------------------------------------
call    InitCommonControls      ;- API Function -

;==============================================================================
; The API function "RegisterClassExA" registers a window class
; This API needs a "WNDCLASSEX" structure so we fill it with correct values
;------------------------------------------------------------------------------
mov     cbSize,30h                      ;size in bytes of WNDCLASSEX structure
mov     style,3h                        ;style, CS_HREDRAW, CS_VREDRAW
mov     lpfnWndProc,OFFSET WP1          ;address of user lpfnWndProc function
mov     cbclsExtra,0h                   ;extra bytes to allocate set to 0
mov     cbWndExtra,0h                   ;class directive in rc file
;------------------------------------------------------------------------------
; API "CreateSolidBrush" creates a logical brush with the specified solid color
;------------------------------------------------------------------------------
push    00600000h                       ;crColor, brush color value RGB, blue
call    CreateSolidBrush                ;- API Function -
mov     hbrBackground,eax               ;handle brush, background color
mov     lpszMenuName,0h                 ;menu name in resource file
mov     lpszClassName,OFFSET ClassName  ;name of windows class
;------------------------------------------------------------------------------
; API "LoadIconA" loads an icon defined in the resource file and store the
; handle in the "WNDCLASSEX" structure
;------------------------------------------------------------------------------
push    1000                            ;icon-string or icon resource id
push    hInstance                       ;our program handle
call    LoadIconA                       ;- API Function -
mov     hIcon,eax                       ;handle of newly loaded icon
mov     hIconSm,eax                     ;iconhandle 0=search in rc file
;------------------------------------------------------------------------------
; API "LoadCursorA" loads a default system cursor, in this case we must set
; hInstance to 0 and lpCursorName to a default system cursor value, here 32512
; Then we store the cursor handle in the "WNDCLASSEX" structure
;------------------------------------------------------------------------------
push    32512                           ;lpCursorName, default value in dezimal
push    0h                              ;hInstance, 0=default system cursor
call    LoadCursorA                     ;- API Function -
mov     hcursor,eax                     ;store handle of the cursor
;------------------------------------------------------------------------------
; Now, after filled the "WNDCLASSEX" structure we call API "RegisterClassEx"
;------------------------------------------------------------------------------
push    OFFSET cbSize                   ;pointer to WNDCLASSEX structure
call    RegisterClassExA                ;- API Function -

;==============================================================================
; API "CreateWindowExA" creates an overlapped, pop-up, or child window with an
; extended style. The return value in EAX is the handle of the new window.
; This API sends a WM_CREATE message to the window procedure (WP1).
;------------------------------------------------------------------------------
push    0h                  ;lpParam, extra pointer data 0=no data
push    hInstance           ;hInstance, handle of our program
push    0h                  ;hMenu, handle window menu 0=class menu
push    0h                  ;hWndParent, handle parent window 0=no
push    Ypos_max            ;intnHeight, window height pixel
push    Xpos_max            ;intnWidth, window width pixel
push    Ypos_org            ;inty, vertical position window
push    Xpos_org            ;intx, horizontal position window
push    02CA0000h           ;dwStyle, look into WIN32.HLP and window.inc
push    OFFSET WindowName   ;lpWindowName, pointer to window name
push    OFFSET ClassName    ;lpClassName, pointer to class name
push    0h                  ;dwExStyle, extra window style 0=no
call    CreateWindowExA     ;- API Function -
mov     hWnd,eax            ;hwnd, return value=handle of window

;==============================================================================
; API "ShowWindow" function sets the specified window's show state. 
;------------------------------------------------------------------------------
push    1h                  ;nCmdShow, show state 1=SW_SHOWNORMAL
push    hWnd                ;hwnd, handle of window
call    ShowWindow          ;- API Function -

;==============================================================================
; API "UpdateWindow" updates the area of the specified window by sending a
; WM_PAINT message to the window if the window's update region is not empty.
;------------------------------------------------------------------------------
push    hWnd                ;hwnd, handle of window
call    UpdateWindow        ;- API Function -

;==============================================================================
; API "GetMessageA" retrieves a message & places it in the specified structure.
;------------------------------------------------------------------------------
LoopGetMessage:
push    0h                  ;wMsgFilterMax, highest message value
push    0h                  ;wMsgFilterMin, lowest message value
push    0h                  ;hWnd, handle of window who gets msg.
push    OFFSET hWnd         ;lpMsg, pointer to MSG structure
call    GetMessageA         ;- API Function -
cmp     eax,0h              ;check if return value=0 (exit)
je      ExitPrg             ;if return value is 0 goto LABEL

;==============================================================================
; API "TranslateMessage" translates key code into ASCII character messages
;------------------------------------------------------------------------------
push    OFFSET hWnd         ;lpMSG, pointer to msg structure
call    TranslateMessage    ;- API Function - keyboard code

;==============================================================================
; API "DispatchMessageA" function dispatches a message to a window procedure.
;------------------------------------------------------------------------------
push    OFFSET hWnd         ;lpMSG, pointer to msg structure
call    DispatchMessageA    ;- API Function -
jmp     LoopGetMessage      ;check for message again, goto LABEL

ExitPrg:
;==============================================================================
; Next we terminate our program (API=ExitProcess)
;------------------------------------------------------------------------------
push    hInstance           ;push our programm handle to exit
call    ExitProcess         ;- API Function -

;##############################################################################
; The Window Procedure lpfnWndProc (API=RegisterClassExA) for this window.
;------------------------------------------------------------------------------
WP1:
push    ebp                 ;create stack frame
mov     ebp,esp             ;
pushad                      ;push all register to the stack

mov     eax,WP1_uMsg        ;move the message number to eax
;==============================================================================
; WM_CREATE (value=01h) message received ?
;------------------------------------------------------------------------------
WP1_uMsg_01h:
cmp     eax,1h                  ;check if WM_CREATE message recieved
jne     WP1_uMsg_02h            ;if not goto label
call    My_EditUpDown           ;- SubRoutine -
call    My_StaticUpDown         ;- SubRoutine -
jmp     WP1_return

;==============================================================================
; WM_DESTROY (value=02h) message received ?
;------------------------------------------------------------------------------
WP1_uMsg_02h:
cmp     eax,2h                  ;check if value=2h (WM_DESTROY)
jne     WP1_uMsg_0Fh            ;if not 2h go to LABEL
xyz:
call    My_CleanSystem          ;- SubRoutine -
;------------------------------------------------------------------------------
; API "PostQuitMessage" indicates to Windows a request to terminate
;------------------------------------------------------------------------------
push    0h                      ;nExitCode, exit code=wParam
call    PostQuitMessage         ;- API Function -
popad                           ;pop all register back from stack
xor     eax,eax                 ;set eax to 0 to exit our program
mov     esp,ebp                 ;delete stack frame
pop     ebp                     ;
ret     10h                     ;return and clear stack

;==============================================================================
; WM_PAINT (value=0Fh) message, used to repaint the window area
;------------------------------------------------------------------------------
WP1_uMsg_0Fh:
cmp     eax,0Fh                 ;check if WM_PAINT message recieved
jne     WP1_uMsg_4Eh            ;if not goto label

jmp     WP1_return

;==============================================================================
; WM_NOTIFY (value=4Eh) message
; With a WM_NOTIFY message Windows gives you pointer to a NMHDR structure.
;------------------------------------------------------------------------------
WP1_uMsg_4Eh:
cmp     eax,4Eh                 ;check if WM_NOTIFY message recieved
jne     WP1_uMsg_7Eh            ;if not goto label
mov     ebx,WP1_lParam          ;pointer to struc, given by windows !
;------------------------------------------------------------------------------
; The NM_UPDOWN structure contains infos about up-down control notification msg.
; The NMHDR structure contains information about a notification message.
; The POINTER to this structure is specified as lParam member of WM_NOTIFY.
; This POINTER is given to us with the WM_NOTIFY message by Windows.
; - NMHDR structure -
; hwndFrom  = [WP1_lParam+0]    ;handle to control sending message 
; idFrom    = [WP1_lParam+4]    ;identifier of control sending message
; code      = [WP1_lParam+8]    ;notification code
;------------------------------------------------------------------------------
; iPos      = [WP1_lParam+12]   ;signed integer, the control's current position
; iDelta    = [WP1_lParam+16]   ;signed integer, proposed change control's pos.
;------------------------------------------------------------------------------
mov     eax,[ebx+0]             ;get the handle of the control sending msg.
NM_EditUpDown:
cmp     eax,hWnd_editupdown     ;is control = edit updown control ?
jne     NM_Static_UpDown        ;
mov     eax,[ebx+8]             ;move code ( NMHDR structure ) into eax
cmp     eax,0FFFFFD2Eh          ;is code UDN_DELTAPOS, UDN_FIRST (0-721)-1
jne     WP1_return              ;if not skip
nop                             ;your code here 
jmp     WP1_return              ;

NM_Static_UpDown:
cmp     eax,hWnd_staticupdown   ;is control = static updown control ?
jne     WP1_return              ;
mov     eax,[ebx+8]             ;move code ( NMHDR structure ) into eax
cmp     eax,0FFFFFD2Eh          ;is code UDN_DELTAPOS, UDN_FIRST (0-721)-1
jne     WP1_return              ;if not skip
;------------------------------------------------------------------------------
; Damned, this seems to be neccassary to prevent an error (no image)
;------------------------------------------------------------------------------
mov     edi,[ebx+12]            ;get current iPos of updown control
cmp     edi,maxImg              ;maximal number of images in resource
jb      NM_Static_UpDown_Low    ;return nonzero to prevent change !
mov     eax,[ebx+16]            ;iDelta,
cmp     eax,1                   ;if +1 skip
je      WP1_return_1            ;return nonzero to prevent change !
NM_Static_UpDown_Low:
cmp     edi,0                   ;lowest number of images in resource
ja      NM_Static_UpDown_OK     ;
mov     eax,[ebx+16]            ;iDelta,
cmp     eax,-1                  ;if -1 skip
je      WP1_return_1            ;return nonzero to prevent change !
NM_Static_UpDown_OK:
;------------------------------------------------------------------------------
; API "DeleteObject" deletes a bitmap, the specified handle is no longer valid.
;------------------------------------------------------------------------------
push    hImg_static             ;hObject, handle object
call    DeleteObject            ;- API Function -
;------------------------------------------------------------------------------
; API "LoadBitmapA" loads a bitmap from the resource file
;------------------------------------------------------------------------------
add     edi,[ebx+16]            ;iDelta (signed ! integer)
add     edi,2000                ;lowest bitmap resource ID !
push    edi                     ;lpBitmapName or resource id
push    hInstance               ;hInstance, handle of modul instance
call    LoadBitmapA             ;- API Function -
mov     hImg_static,eax         ;hObject, handle of graphic object
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
push    hImg_static             ;push handle of the bitmap
push    0h                      ;wParam, fImageType, IMAGE_BITMAP=0h
push    172h                    ;uMsg, STM_SETIMAGE=172h
push    hWnd_static             ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
jmp     WP1_return              ;

;==============================================================================
; WM_DISPLAYCHANGE (value=7Eh) message, used to repaint the window area
;------------------------------------------------------------------------------
WP1_uMsg_7Eh:
cmp     eax,7Eh                     ;check if WM_DISPLAYCHANGE message recieved
jne     WP1_uMsg_111h               ;if not goto label
;------------------------------------------------------------------------------
; API "InvalidateRect" adds a rectangle to specified window's update region.
; This function performs a WM_PAINT message.
;------------------------------------------------------------------------------
push    0h                          ;bErase, erase-background flag
push    0h                          ;lpRect, rect structure, 0h=client area
push    WP1_hWnd                    ;hWnd, handle window update region
call    InvalidateRect              ;- API Function -
jmp     WP1_return

;==============================================================================
; WM_COMMAND (value=111h) message recieved ?
;------------------------------------------------------------------------------
WP1_uMsg_111h:
cmp     eax,111h                ;check if WM_COMMAND message recieved
jne     WP1_uMsg_112h           ;if not goto label

jmp     WP1_return

;==============================================================================
; WM_SYSCOMMAND (value=112h) message recieved ?
;------------------------------------------------------------------------------
WP1_uMsg_112h:
cmp     eax,112h                ;check if WM_COMMAND message recieved
jne     WP1_return              ;if not goto label
mov     eax,WP1_wParam          ;extra info about the message
cmp     eax,0F060h              ;SC_CLOSE=0F060h received ?
jne     WP1_return              ;
call    My_CleanSystem          ;- SubRoutine -
jmp     WP1_return

;==============================================================================
; API "DefWindowProcA" calls the window procedure to provide default processing
; for any window messages that an application does not process.
; This function ensures that every message is processed.
; It is called with the same parameters received by the window procedure.
;------------------------------------------------------------------------------
WP1_return:
popad                           ;pop all register from stack
push    WP1_lParam              ;extra info about the message
push    WP1_wParam              ;extra info about the message
push    WP1_uMsg                ;the message number
push    WP1_hWnd                ;handle of window who receives message
call    DefWindowProcA          ;- API Function -
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     10h                     ;return and clear stack

;==============================================================================
; Leaving the window procedure returning TRUE (1) or FALSE (0) in EAX.
;------------------------------------------------------------------------------
WP1_return_0:
popad                           ;pop all register from stack
mov     eax,0h                  ;set EAX to FALSE (0)
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     10h                     ;return and clear stack
WP1_return_1:
popad                           ;pop all register from stack
mov     eax,1h                  ;set EAX to TRUE (1)
mov     esp,ebp                 ;delete stack frame
pop     ebp
ret     10h                     ;return and clear stack
;##############################################################################

;******************************************************************************
; My own subroutine(s) for a compacter code resist here ...
;------------------------------------------------------------------------------
My_EditUpDown:
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined class name (EDIT).
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
push    200h                    ;hMenu, the child-window ID
push    WP1_hWnd                ;hWndParent, handle parent window 0=no
push    18h                     ;intnHeight, window height pixel
push    11Ch                    ;intnWidth, window width pixel
push    08h                     ;inty, vertical position window
push    10h                     ;intx, horizontal position window
push    54002000h               ;dwStyle, ES_NUMBER=2000h, ES_READONLY=800h
push    0h                      ;lpWindowName, pointer to window name
push    OFFSET EditClassName    ;lpClassName, pointer to class name
push    300h                    ;dwExStyle, look WIN32.HLP + windows.inc
call    CreateWindowExA         ;- API Function -
mov     hWnd_edit,eax           ;hwnd, store handle of window
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined class name (UPDOWN).
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
push    201h                    ;hMenu, the child-window ID
push    WP1_hWnd                ;hWndParent, handle parent window 0=no
push    0h                      ;intnHeight, window height pixel
push    0h                      ;intnWidth, window width pixel
push    0h                      ;inty, vertical position window
push    0h                      ;intx, horizontal position window
push    54000126h               ;dwStyle, UDS_HOTTRACK=100h, UDS_ARROWKEYS =20h
                                ;         UDS_ALIGNRIGHT=4h, UDS_SETBUDDYINT=2h
push    0h                      ;lpWindowName, pointer to window name
push    OFFSET UpDownClassName  ;lpClassName, pointer to class name
push    0h                      ;dwExStyle, look WIN32.HLP + windows.inc
call    CreateWindowExA         ;- API Function -
mov     hWnd_editupdown,eax     ;hwnd, store handle of window
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the specified window
;------------------------------------------------------------------------------
push    0h                      ;lParam, 
push    hWnd_edit               ;wParam, hwndBuddy, handle to new buddy window
push    469h                    ;uMsg, UDM_SETBUDDY, WM_USER(400h)+105
push    hWnd_editupdown         ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the specified window
;------------------------------------------------------------------------------
push    0h                      ;lParam, 
push    10                      ;wParam, nBase, 10=decimal 16=hexadecimal
push    46Dh                    ;uMsg, UDM_SETBASE, WM_USER(400h)+109
push    hWnd_editupdown         ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
;------------------------------------------------------------------------------
; API "SendMessageA" sends a message to the specified window
;------------------------------------------------------------------------------
push    +257                    ;lParam, iHigh, signed integer, upper limit
push    -257                    ;wParam, iLow, signed integer, lower limit
push    46Fh                    ;uMsg, UDM_SETRANGE32, WM_USER(400h)+111
push    hWnd_editupdown         ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
ret

My_StaticUpDown:
;------------------------------------------------------------------------------
; API "CreateWindowExA" creates a window with a predefined class name (STATIC).
;------------------------------------------------------------------------------
push    0h                      ;lpParam, extra pointer data 0=no data
push    hInstance               ;hInstance, handle of our program
push    300h                    ;hMenu, the child-window ID
push    WP1_hWnd                ;hWndParent, handle parent window 0=no
push    0A0h                    ;intnHeight, window height pixel
push    11Ch                    ;intnWidth, window width pixel
push    28h                     ;inty, vertical position window
push    10h                     ;intx, horizontal position window
push    5400020Eh               ;dwStyle, SS_CENTERIMAGE=200h, SS_BITMAP=0Eh
push    0h                      ;lpWindowName, pointer to window name
push    OFFSET StaticClassName  ;lpClassName, pointer to class name
push    0h                      ;dwExStyle, look WIN32.HLP + windows.inc
call    CreateWindowExA         ;- API Function -
mov     hWnd_static,eax         ;hwnd, store handle of window
;------------------------------------------------------------------------------
; API "CreateUpDownControl" creates an up-down control
;------------------------------------------------------------------------------
push    0h                      ;nPos, position of the control
push    0h                      ;nLower, lower limit (range) of the up-down control
push    maxImg                  ;nUpper, upper limit (range) of the up-down control
push    hWnd_static             ;hBuddy, handle window associated with up-down control
push    hInstance               ;hInst, handle to the module instance
push    301h                    ;nID, identifier for the up-down control
push    WP1_hWnd                ;hParent, handle to the parent window 
push    0h                      ;cy, height, in pixels, of the up-down control
push    0h                      ;cx, width, in pixels, of the up-down control
push    0h                      ;y,vertical client coordinate,upper-left corner
push    0h                      ;x,horizontal client coordinate,upper-left corner
push    54000104h               ;dwStyle, UDS_HOTTRACK=100h, UDS_ALIGNRIGHT=4h
call    CreateUpDownControl     ;- API Function -
mov     hWnd_staticupdown,eax   ;hwnd, store handle of window
;------------------------------------------------------------------------------
; API "LoadBitmapA" loads a bitmap from the resource file
;------------------------------------------------------------------------------
push    2000                    ;lpBitmapName, bitmap resource ID
push    hInstance               ;hInstance, handle of modul instance
call    LoadBitmapA             ;- API Function -
mov     hImg_static,eax         ;hObject, handle of graphic object
;------------------------------------------------------------------------------
; API "SendMessage" sends the specified message to a window.
;------------------------------------------------------------------------------
push    hImg_static             ;push handle of the bitmap
push    0h                      ;wParam, fImageType, IMAGE_BITMAP=0h
push    172h                    ;uMsg, STM_SETIMAGE=172h
push    hWnd_static             ;hwnd, handle of destination window
call    SendMessageA            ;- API Function -
ret

My_CleanSystem:
;------------------------------------------------------------------------------
; API "DeleteObject" deletes a logical pen, brush, font, bitmap, region, or
; palette, freeing all system resources associated with the object.
; After the object is deleted, the specified handle is no longer valid.
;------------------------------------------------------------------------------
push    hImg_static             ;hObject, handle object
call    DeleteObject            ;- API Function -
ret
;******************************************************************************

;==============================================================================
; end Main = end of our program code
;------------------------------------------------------------------------------
end Main                                ;end of our program code, entry point

;==============================================================================
; To create the exe file use this commands with your Microsoft Assembler/Linker
;------------------------------------------------------------------------------
; ml.exe /c /coff td_win32asm_014.asm                           ;asm command
; rc.exe /v rsrc.rc                                             ;rc command
; cvtres.exe /machine:ix86 rsrc.res
; link.exe /subsystem:windows td_win32asm_014.obj rsrc.obj      ;link command
;==============================================================================